Poj 3255(Dijkstra求次短路)

Roadblocks
Time Limit: 2000MS   Memory Limit: 65536K
Total Submissions: 5564   Accepted: 2111

Description

Bessie has moved to a small farm and sometimes enjoys returning to visit one of her best friends. She does not want to get to her old home too quickly, because she likes the scenery along the way. She has decided to take the second-shortest rather than the shortest path. She knows there must be some second-shortest path.

The countryside consists of R (1 ≤ R ≤ 100,000) bidirectional roads, each linking two of the N (1 ≤ N ≤ 5000) intersections, conveniently numbered 1..N. Bessie starts at intersection 1, and her friend (the destination) is at intersection N.

The second-shortest path may share roads with any of the shortest paths, and it may backtrack i.e., use the same road or intersection more than once. The second-shortest path is the shortest path whose length is longer than the shortest path(s) (i.e., if two or more shortest paths exist, the second-shortest path is the one whose length is longer than those but no longer than any other path).

Input

Line 1: Two space-separated integers: N and R
Lines 2.. R+1: Each line contains three space-separated integers: A, B, and D that describe a road that connects intersections A and B and has length D (1 ≤ D ≤ 5000)

Output

Line 1: The length of the second shortest path between node 1 and node N

Sample Input

4 4
1 2 100
2 4 200
2 3 250
3 4 100

Sample Output

450

Hint

Two routes: 1 -> 2 -> 4 (length 100+200=300) and 1 -> 2 -> 3 -> 4 (length 100+250+100=450)

Source

USACO 2006 November Gold
Dijkstra求最短路的思想是依次确定尚未确定的定点中距离最小的顶点,求次短路也可以根据这个思路来。关键是要认识到到某个顶点的次短路要么是到其他某个顶点u的最短路再加上u->v的边,要么是到u的次短路再加上u->v的边,因此所需要求的就是所有顶点的最短路和次短路。
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<vector>
#include<map>
#include<cmath>
#include<queue>
#include<iostream>
using namespace std;
const int maxn = 5000 + 5;
const int INF = 100000000;
typedef long long LL;
typedef pair<int,int> P;

int n,r;
struct edge{
    int to,cost;
};
vector<edge> G[maxn];

int dist[maxn];
int dist2[maxn];

void solve(){
    priority_queue<P,vector<P>,greater<P> > que;
    fill(dist,dist+n,INF);
    fill(dist2,dist2+n,INF);
    dist[0] = 0;
    que.push(P(0,0));

    while(!que.empty()){
        P p = que.top();que.pop();
        int v = p.second,d = p.first;
        if(dist2[v] < d ) continue;
        for(int i = 0;i < G[v].size();i++){
            edge &e = G[v][i];
            int d2 = d + e.cost;
            if(dist[e.to] > d2){
                swap(dist[e.to],d2);
                que.push(P(dist[e.to],e.to));
            }
            if(dist2[e.to] > d2 && dist[e.to] < d2){
                dist2[e.to] = d2;
                que.push(P(dist2[e.to],e.to));
            }
        }
    }
    printf("%d\n",dist2[n-1]);
}

int main(){
    while(scanf("%d%d",&n,&r) != EOF){
        for(int i = 0;i <= n;i++) G[i].clear();
        for(int i = 0;i < r;i++){
            int x,y,z;
            scanf("%d%d%d",&x,&y,&z);
            x--;y--;
            G[x].push_back(edge{y,z});
            G[y].push_back(edge{x,z});
        }
        solve();
    }
    return 0;
}


你可能感兴趣的:(Poj 3255(Dijkstra求次短路))